<?php

// User Management functions

function UserExists($UserID)
{
if (QueryUserInfo($UserID) != -4)
   return TRUE;
return FALSE;
}

function SearchUserIDs($ANick,$AName,$ALastName,$AEmail,$AWeb,$AOnline,$AGender,$ACity,$AStat,$Start)
// retrieves the list of user IDs which match up to the criteriums
{
require_once('funkce_mysql.php');
require_once('funkce_general.php');
DefineConstants();
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="SELECT `ID` FROM users WHERE ";
if ($ANick != "")
   $query.="`Nick` LIKE '".$ANick."%' AND ";
if ($AName != "")
   $query.="`Name` LIKE '%".$AName."%' AND ";
if ($ALastName != "")
   $query.="`LastName` LIKE '%".$ALastName."%' AND ";
if ($AWeb != "")
   $query.="`Web` LIKE '%".$AWeb."%' AND ";
if ($AEmail != "")
   $query.="`Email` LIKE '%".$AEmail."%' AND ";
if ($ACity != "")
   $query.="`City` LIKE '%".$ACity."%' AND ";
if ($AGender != "2")
   $query.="`Gender` = ".$AGender." AND ";
if ($AOnline != "2")
   $query.="`Online` = ".$AOnline." AND "; 
if ($AStat != "0")
   $query.="`State` LIKE '".$AStat."' AND ";
if (strlen($query) != 29)
   $query=substr($query,0,-4)." LIMIT ".$Start.", ".POCET_NA_STRANU.";";
else $query="SELECT `ID` FROM users LIMIT ".$Start.", ".POCET_NA_STRANU.";";
if (!$vysledek=mysql_query($query))
   return -3;

$vyslednepole[0]=0;
while ($pole=mysql_fetch_array($vysledek))
      $vyslednepole[]=$pole['ID'];
return $vyslednepole;
}

function WriteUsers($Start)
// writes users into table
{
require_once('funkce_general.php');
$IDs=SearchUserIDs(POST("APrezdivka"),POST("AJmeno"),POST("APrijmeni"),POST("AEmail"),POST("AWeb"),POST("AOnline"),POST("APohlavi"),POST("ACity"),POST("AStat"),$Start);
$Count=0;
if (count($IDs) < 2)
   echo "<tr class='tcell'> <td colspan=4> dn uivatel nebyl nalezen </td> </tr>";
for ( $I=1; $I < count($IDs); ++$I)
    {
    ++$Count;
    echo "<tr class='tcell'>";
    $User=QueryUserInfo($IDs[$I]);
    echo "<td> ", WriteUser($User["Nick"]), " </td> ";
    echo "<td> ", $User["Name"], " </td> ";
    echo "<td> ", $User["LastName"], " </td> ";
    echo "<td> ";
    echo "<div> <a href='../users/showinfo.php?ID=".$User["ID"]."' target='Pravy'> Informace </a> </div>";
    echo "<div> <a href='../adresar/adduserform.php?UserName=".$User["Nick"]."' target='Pravy'> Pidat do adrese </a> </div>";
    echo "<div> <a href='../files/send.php?AUserName=".$User["Nick"]."'> Poslat soubor </a> </div>";
    echo "<div> <a href='../connections/send.php?AUserName=".$User["Nick"]."' target='Pravy'> Poslat pozvnku </a> </div>";
    echo "</td> </tr>";
    }
return $Count;
}

function CurrentUser()
// retrieves the ID of current logged user
{
return $_SESSION["UserID"];
}

function UserChangeInfo($User)
// Changes the user profile
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="UPDATE users SET ".
        "`Name`='".$User["Name"]."',".
	"`Lastname`='".$User["LastName"]."',".
	"`Email`='".$User["Email"]."',".
	"`City`='".$User["City"]."',".
	"`State`='".$User["State"]."',".
	"`Web`='".$User["Web"]."',".
	"`Description`='".$User["Description"]."',".
	"`Gender`=".$User["Gender"].",".
	"`Password`='".$User["Password"]."',".
	"`Color`='".$User["Color"]."',".
	"`Born`='".$User["Born"]."' WHERE `ID`=".$User["ID"].";";
if (!mysql_query($query))
   return -3;
return 1;
}

function WriteUser($ANick)
// writes user nick. when the user is online the color is red otherwise the color is black
{
$ID=UserNickToUserID($ANick);
if (IsUserOnline($ID))
   echo "<font color='red'>".$ANick."</font>";
else echo $ANick;
return "";
}

function WriteUserByID($UserID)
{
$pole=QueryUserInfo($UserID);
WriteUser($pole["Nick"]);
}

function UserNickToUserID($ANick)
// transforms the name specified in ANICK to user ID
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="SELECT `ID` FROM users WHERE `Nick` LIKE '".$ANick."';";
if (!$vysledek=mysql_query($query))
   return -3;
if (!$pole=mysql_fetch_array($vysledek))
   return -4;
return $pole["ID"];
}

function DestroyUser()
// Destroys user account of uswer wchich is logged on
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="DELETE FROM users WHERE `ID` = ".$_SESSION["UserID"].";";
$vysledek=mysql_query($query);
if (!$vysledek)
   return -3;
$query="DELETE FROM adresar WHERE (`OwnerID`=".$_SESSION["UserID"]." OR `UserID`=".$_SESSION["UserID"].");";
if (!mysql_query($query))
   return -3;
$query="DELETE FROM pozvanky WHERE `UserID`=".$_SESSION["UserID"].";";
if (!mysql_query($query))
   return -3;
return 1;
}

function ChangeUserState($Online)
// Changes user state:
// 0 = OFFLINE
// 1 = ONLINE
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="UPDATE users SET `Online`=".$Online." WHERE `ID`=".$_SESSION['UserID'].";";
if (!mysql_query($query))
   return -3;
return 1;
}

function LogOffUser()
// Logs off current user
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="UPDATE users SET `NaposledyOnline`='".date('Y-m-d H:i:s')."' WHERE `ID`=".CurrentUser().";";
if (!mysql_query($query))
   return -3;
ChangeUserState(0);
$_SESSION_["UserID"]=0;
session_destroy();
return 1;
}

function AddUser($APrezdivka,$AJmeno,$APrijmeni,$AEmail,$APassword,$APohlavi,$AStat,$ACity,$APopis,$AWeb,$AColor,$AYear,$AMonth,$ADay)
// Adds user to the database. This is done after successfull registration
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="SELECT * FROM users WHERE `Nick`='".$APrezdivka."';";
if (!$vysledek=mysql_query($query))
   return -3;
if ($pole=mysql_fetch_array($vysledek))
   return -6;
$query="INSERT INTO users VALUES ('".$APrezdivka."', '".$AJmeno."', '".$APrijmeni."', '".$AEmail."', '".$APopis."', '".$AStat."', '".$ACity."', '', 0,'' , '".$APassword."', ".$APohlavi.",'".$AWeb."','".$AColor."','0000-00-00 00:00:00','0000-00-00 00:00:00','".$AYear."-".$AMonth."-".$ADay."');";
if (!mysql_query($query))
   return -3;
return 1;
}

function QueryUserInfo($UID)
// Retrieves the information about user specified by UID
{
require_once('funkce_mysql.php');
if (!MySQLConnect())
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="SELECT * FROM users WHERE `ID`=".$UID.";";
if (!$vysledek=mysql_query($query))
   return -3;
if ($pole=mysql_fetch_array($vysledek))
   return $pole;
else return -4;
}

function GetUserNick($UserID)
// retrieves the nick of the user USERID
{
$pole=QueryUserInfo($UserID);
return $pole["Nick"];
}

function IsUserOnline($UserID)
// returns the state of user USERID
{
require_once('funkce_general.php');
CustomErrorCheck(QueryUserInfo($UserID));
$pole=QueryUserInfo($UserID);
if ($pole["Online"] == 1)
   return TRUE;
return FALSE;
}

function LogOnUser($Name,$Pass)
// Logs on user specified by username Name and password Pass
{
require_once('funkce_mysql.php');
require_once('funkce_connections.php');
$spojeni=MySQLConnect();
if (!$spojeni)
   return -1;
if (!MySQLSelectDB())
   return -2;
$query="SELECT `Password`,`ID`,`Nick` FROM users";
$vysledek=mysql_query($query);
if (!$vysledek)
   return -3;
while ($pole=mysql_fetch_array($vysledek))
      {
      if ((stripslashes($pole["Password"]) == $Pass) AND ($pole["Nick"] == $Name))
	 {
	 if (IsUserOnline($pole["ID"]))
	    return -7;
	 $_SESSION["UserID"]=$pole["ID"];
	 @mkdir('users/'.$_SESSION["UserID"]);
	 mysql_close($spojeni);
	 ChangeUserState(1);
	 $query="UPDATE users SET `OnlineOd`='".date('Y-m-d H:i:s')."' WHERE `ID`=".$pole["ID"].";";
	 mysql_query($query);
	 return 1;
	 }
      }
mysql_close($spojeni);
return -4;
}

?>