<?php

// General functions

function KontrolaDataKanalu()
{
require_once('funkce_channels.php');
$pole=EnumAllChannels();
for ($I=1; $I <= $pole[0]; ++$I)
    {
    if (
       (GetYear(date("Y-m-d H:i:s")) - GetYear($pole[$I]["LastUpdated"]) > 0) OR
       (GetMonth(date("Y-m-d H:i:s")) - GetMonth($pole[$I]["LastUpdated"]) > 0) OR
       (GetDay(date("Y-m-d H:i:s")) - GetDay($pole[$I]["LastUpdated"]) > 1) 
       )
       {
       $_SESSION["UserID"]=$pole[$I]["UserID"];
       DeleteChannel($pole[$I]["ID"]);
       unset($_SESSION["UserID"]);
       }
    }
}

function KontrolaDataSouboru()
{
require_once('funkce_files.php');
$pole=EnumAllFiles();
for ($I=1; $I <= $pole[0]; ++$I)
    {
    if (
       (GetYear(date("Y-m-d H:i:s")) - GetYear($pole[$I]["Added"]) > 0) OR
       (GetMonth(date("Y-m-d H:i:s")) - GetMonth($pole[$I]["Added"]) > 0) OR
       (GetDay(date("Y-m-d H:i:s")) - GetDay($pole[$I]["Added"]) > 0) 
       )
       {
       $_SESSION["UserID"]=$pole[$I]["UserID"];
       FileDelete($pole[$I]["ID"]);
       unset($_SESSION["UserID"]);
       }
    }
}


function DefineConstants()
// defines a constants used by PHPMessenger
{
if (!defined("POCET_NA_STRANU"))
   define("POCET_NA_STRANU",10);
}

function IntToColor($Int)
{
if ($Int == 0) return "000000";
if ($Int == 127) return "00007F";
if ($Int == 255) return "0000FF";
if ($Int == 0+7*16*16*16+15*256) return "007F00";
if ($Int == 127+7*16*16*16+15*256) return "007F7F";
if ($Int == 255+7*16*16*16+15*256) return "007FFF";
if ($Int == 0+15*16*16*16+15*256) return "00FF00";
if ($Int == 127+15*16*16*16+15*256) return "00FF7F";
if ($Int == 255+15*16*16*16+15*256) return "00FFFF";
if ($Int == 0+7*16*16*16*16*16+15*65536) return "7F0000";
if ($Int == 127+7*16*16*16*16*16+15*65536) return "7F007F";
if ($Int == 255+7*16*16*16*16*16+15*65536) return "7F00FF";
if ($Int == 0+7*16*65536+15*65536+7*16*256+15*256) return "7F7F00";
if ($Int == 127+7*16*65536+15*65536+7*16*256+15*256) return "7F7F7F";
if ($Int == 255+7*16*65536+15*65536+7*16*256+15*256) return "7F7FFF";
if ($Int == 0+7*16*65536+15*65536+15*16*256+15*256) return "7FFF00";
if ($Int == 127+7*16*65536+15*65536+15*16*256+15*256) return "7FFF7F";
if ($Int == 255+7*16*65536+15*65536+15*16*256+15*256) return "7FFFFF";
if ($Int == 0+15*16*65536+15*65536) return "FF0000";
if ($Int == 127+15*16*65536+15*65536) return "FF007F";
if ($Int == 255+15*16*65536+15*65536) return "FF00FF";
if ($Int == 0+15*16*65536+15*65536+7*16*256+15*256) return "FF7F00";
if ($Int == 127+15*16*65536+15*65536+7*16*256+15*256) return "FF7F7F";
if ($Int == 255+15*16*65536+15*65536+7*16*256+15*256) return "FF7FFF";
if ($Int == 0+15*16*65536+15*65536+15*16*256+15*256) return "FFFF00";
if ($Int == 127+15*16*65536+15*65536+15*16*256+15*256) return "FFFF7F";
if ($Int == 255+15*16*65536+15*65536+15*16*256+15*256) return "FFFFFF";
Alert("Chyba! - ".$Int);
}

function ColorToInt($Color)
// converts hex color to integer
{
if ($Color == "#000000") return 0;
if ($Color == "#00007F") return 127;
if ($Color == "#0000FF") return 255;
if ($Color == "#007F00") return 32512;
if ($Color == "#007F7F") return 32639;
if ($Color == "#007FFF") return 32767;
if ($Color == "#00FF00") return 65280;
if ($Color == "#00FF7F") return 65407;
if ($Color == "#00FFFF") return 65535;
if ($Color == "#7F0000") return 8323072;
if ($Color == "#7F007F") return 8323199;
if ($Color == "#7F00FF") return 8323327;
if ($Color == "#7F7F00") return 8355584;
if ($Color == "#7F7F7F") return 8355711;
if ($Color == "#7F7FFF") return 8355839;
if ($Color == "#7FFF00") return 8388352;
if ($Color == "#7FFF7F") return 8388479;
if ($Color == "#7FFFFF") return 8388607;
if ($Color == "#FF0000") return (8323072 + 7 * 16*16*16*16*16);
if ($Color == "#FF007F") return (8323199 + 7 * 16*16*16*16*16);
if ($Color == "#FF00FF") return (8323327 + 7 * 16*16*16*16*16);
if ($Color == "#FF7F00") return (8355584 + 7 * 16*16*16*16*16);
if ($Color == "#FF7F7F") return (8355711 + 7 * 16*16*16*16*16);
if ($Color == "#FF7FFF") return (8355839 + 7 * 16*16*16*16*16);
if ($Color == "#FFFF00") return (8388352 + 7 * 16*16*16*16*16);
if ($Color == "#FFFF7F") return (8388479 + 7 * 16*16*16*16*16);
if ($Color == "#FFFFFF") return (8388607 + 7 * 16*16*16*16*16);
Alert("Chyba! - ".$Color);
}

function CreateColorComboBox($SelectedColor)
// creates a colorcombobox
{
echo "<SELECT name='ABarva'>";
CreateComboBoxItem(0,"#000000",$SelectedColor);
CreateComboBoxItem(127,"#00007F",$SelectedColor);
CreateComboBoxItem(255,"#0000FF",$SelectedColor);
CreateComboBoxItem(32512,"#007F00",$SelectedColor);
CreateComboBoxItem(32639,"#007F7F",$SelectedColor);
CreateComboBoxItem(32767,"#007FFF",$SelectedColor);
CreateComboBoxItem(65280,"#00FF00",$SelectedColor);
CreateComboBoxItem(65407,"#00FF7F",$SelectedColor);
CreateComboBoxItem(65535,"#00FFFF",$SelectedColor);
CreateComboBoxItem(8323072,"#7F0000",$SelectedColor);
CreateComboBoxItem(8323199,"#7F007F",$SelectedColor);
CreateComboBoxItem(8323327,"#7F00FF",$SelectedColor);
CreateComboBoxItem(8355584,"#7F7F00",$SelectedColor);
CreateComboBoxItem(8355711,"#7F7F7F",$SelectedColor);
CreateComboBoxItem(8355839,"#7F7FFF",$SelectedColor);
CreateComboBoxItem(8388352,"#7FFF00",$SelectedColor);
CreateComboBoxItem(8388479,"#7FFF7F",$SelectedColor);
CreateComboBoxItem(8388607,"#7FFFFF",$SelectedColor);
CreateComboBoxItem(16711680,"#FF0000",$SelectedColor);
CreateComboBoxItem(16711807,"#FF007F",$SelectedColor);
CreateComboBoxItem(16711935,"#FF00FF",$SelectedColor);
CreateComboBoxItem(16744192,"#FF7F00",$SelectedColor);
CreateComboBoxItem(16744319,"#FF7F7F",$SelectedColor);
CreateComboBoxItem(16744447,"#FF7FFF",$SelectedColor);
CreateComboBoxItem(16776960,"#FFFF00",$SelectedColor);
CreateComboBoxItem(16777087,"#FFFF7F",$SelectedColor);
echo "</SELECT>";
}

function CreateComboBoxItem($Value,$BgColor,$Selected)
// creates one item of colorcombobox
{
echo "<OPTION name='ABarva' style='color:".$BgColor.";' style='background-color:".$BgColor.";' value='".$Value."' ";
if ($Value == $Selected)
   echo " SELECTED ";
echo "> #".$BgColor." </OPTION> \n";
}

function GetYear($D)
// retrieves year from date yyyy-mm-dd
{
return substr($D,0,4);
}

function GetMonth($D)
// retrieves month from date yyyy-mm-dd
{
return substr($D,5,2);
}

function GetDay($D)
// retrieves day from date yyyy-mm-dd
{
return substr($D,8,2);
}

function EmailJakoOdkaz($Email)
// writes an email address EMAIL like hyperlink
{
echo "<a href='mailto:".$Email."'> ".$Email." </a> ";
}

function WebJakoOdkaz($Web)
// writes a URL WEB like hyperlink
{
echo "<a href='".$Web."' target='_blank'> ".$Web." </a> ";
}

function POST($variable)
// retrieves the value of variable VARIABLE in $_POST array
{
return $_POST[$variable];
}

function RedirectTo($Address)
// redirects to page specified by ADDRESS
{
echo "<script language='javascript'>";
echo "location.href='".$Address."';";
echo "</script>";
}

function KontrolaEmailu($Email)
// verifies email address
{
if ($Email == "")
   return FALSE;
if (ereg("^\.",$Email))
   return FALSE;
if (ereg("\.$",$Email))
   return FALSE;
if (!ereg("@",$Email))
   return FALSE;
if (ereg("\.@",$Email))
   return FALSE;
if (ereg("@\.",$Email))
   return FALSE;
if (!ereg("^[a-zA-Z0-9@.]+$",$Email))
   return FALSE;
if (ereg('^@',$Email))
   return FALSE;
if (ereg('@$',$Email))
   return FALSE;
return TRUE;
}

function KontrolaSeznamu($Seznam)
// verifies a list of items
{
if (ereg("^[a-zA-Z0-9]+$",$Seznam))
   return TRUE;
if (ereg("^(([a-zA-Z0-9]+),)+([0-9a-zA-Z]+)$",$Seznam))
   return TRUE;
return FALSE;
}

function KontrolaUsera($User)
// verifies user nick
{
if (ereg("^[a-zA-Z0-9]+$",$User))
   return TRUE;
return FALSE;
}

function KontrolaData($AYear,$AMonth,$ADay)
// verifies date
{
if (($AYear == "0000") OR ($ADay == "00") OR ($AMonth == "00"))
   return TRUE;
if (($AMonth == "01") OR
    ($AMonth == "03") OR
    ($AMonth == "05") OR
    ($AMonth == "07") OR
    ($AMonth == "08") OR
    ($AMonth == "10") OR
    ($AMonth == "12"))
    {
    return TRUE;
    }
if (($AMonth == "04") OR
    ($AMonth == "06") OR
    ($AMonth == "09") OR
    ($AMonth == "11"))
    {
    if ($ADay != "31")
       return TRUE;
    return FALSE;
    }
if ($AMonth == "02")
   {
   if (($ADay <= 28) AND ($AYear%4 != 0))
      return TRUE;
   if (($ADay <=29) AND ($AYear%4 == 0))
      return TRUE;
   return FALSE;
   }
else Alert("Chyba!");
return FALSE;
}

function Reload()
// Does the same as "Aktualizovat"
{
echo "<script language='javascript1.2'>";
echo "top.location.href='/rocnik3/index.php';";
echo "</script>";
}

function Alert($Msg)
// Does the same as WinAPI MessageBoxA
{
echo "<script language='javascript'>";
echo "alert('".$Msg."');";
echo "</script>";
return 1;
}

function CustomErrorCheck($Err)
{
switch ($Err)
	{
	case -9:
	 Alert('File not exist');
	 break;
	case -8:
	 Alert("Nepodailo se zkoprovat soubor");
	case -7:
	 Alert("User is already loggen on!");
	 break;
	case -6:
	 Alert("User with this nickname already exists");
	 break;
	case -5:
	 Alert("This user is alredy in your favourites!");
	 break;
	case -4:
	 Alert("No such user exists");
	 break;
	case -3:
	 Alert("Error in SQL query!");
	 break;
	case -2:
	 Alert("Could not select DB");
	 break;
	case -1:
	 Alert("Could not reach the server");
	 break;
        case 0:
	 Alert("Uivatel ji m pozvnku k tomuto kanlu");
	 break;
	default:
	 return TRUE;
	}
return FALSE;
}
?>